VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "howto_measure_map"
   ClientHeight    =   7920
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   8100
   LinkTopic       =   "Form1"
   ScaleHeight     =   7920
   ScaleWidth      =   8100
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox cboUnits 
      Height          =   315
      ItemData        =   "Form1.frx":0000
      Left            =   600
      List            =   "Form1.frx":0013
      Style           =   2  'Dropdown List
      TabIndex        =   5
      Top             =   150
      Width           =   1455
   End
   Begin VB.CommandButton cmdMeasure 
      Caption         =   "Measure"
      Enabled         =   0   'False
      Height          =   375
      Left            =   5040
      TabIndex        =   3
      Top             =   120
      Width           =   1095
   End
   Begin VB.CommandButton cmdSetScale 
      Caption         =   "Set Scale"
      Enabled         =   0   'False
      Height          =   375
      Left            =   2280
      TabIndex        =   2
      Top             =   120
      Width           =   1095
   End
   Begin MSComDlg.CommonDialog dlgFile 
      Left            =   3840
      Top             =   2880
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      Filter          =   "Image Files|*.bmp;*.gif;*.tif;*.png;*.jpg|All Files|*.*"
   End
   Begin VB.PictureBox picMap 
      Height          =   1215
      Left            =   120
      ScaleHeight     =   1155
      ScaleWidth      =   1035
      TabIndex        =   0
      Top             =   600
      Visible         =   0   'False
      Width           =   1095
   End
   Begin VB.Label lblDistance 
      AutoSize        =   -1  'True
      Height          =   195
      Left            =   6240
      TabIndex        =   7
      Top             =   200
      Width           =   45
   End
   Begin VB.Label lblScale 
      AutoSize        =   -1  'True
      Height          =   195
      Left            =   3480
      TabIndex        =   6
      Top             =   200
      Width           =   45
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Units:"
      Height          =   195
      Left            =   120
      TabIndex        =   4
      Top             =   200
      Width           =   405
   End
   Begin VB.Label lblInstructions 
      BorderStyle     =   1  'Fixed Single
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   3840
      Width           =   1215
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open..."
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileOpenSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Known units.
Private Enum Units
    Undefined = -1
    Miles = 0
    Yards = 1
    Feet = 2
    Kilometers = 3
    Meters = 4
End Enum

' What we are doing.
Private Enum MouseStates
    Undefined
    ScaleStart
    ScaleEnd
    MeasureStart
    MeasureEnd
End Enum
Private MouseState As MouseStates

' Key map values.
Private ScaleDistanceInUnits As Double
Private ScaleDistanceInPixels As Double
Private CurrentUnit As Units
Private CurrentDistance As Double

' Scale information.
Private ScaleStartX As Single
Private ScaleStartY As Single
Private ScaleEndX As Single
Private ScaleEndY As Single

' Measurement information.
Private MeasurementXs As Collection
Private MeasurementYs As Collection

Private Sub Form_Load()
    ScaleDistanceInUnits = -1
    ScaleDistanceInPixels = -1
    CurrentDistance = -1
    MouseState = MouseStates.Undefined

    picMap.AutoRedraw = True
    picMap.AutoSize = True
    picMap.ScaleMode = vbPixels
    dlgFile.CancelError = True
    cboUnits.ListIndex = 0
End Sub

Private Sub Form_Resize()
Dim wid As Single

    wid = ScaleWidth - 2 * lblInstructions.Left
    lblInstructions.Move _
        lblInstructions.Left, _
        Me.ScaleHeight - lblInstructions.Height - lblInstructions.Left, _
        wid
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub

' Open a map image.
Private Sub mnuFileOpen_Click()
    On Error GoTo OpenError
    dlgFile.ShowOpen
    picMap.Picture = LoadPicture(dlgFile.FileName)
    picMap.Visible = True

    cmdSetScale.Enabled = True
    cmdMeasure.Enabled = True
    CurrentUnit = Units.Undefined
    DisplayValues
    Exit Sub

OpenError:
    If Err.Number <> cdlCancel Then
        MsgBox "Error " & Err.Number & " opening file." & vbCrLf & Err.Description, _
            vbExclamation Or vbOKOnly, _
            "Error"
    End If
End Sub

' Set the scale.
Private Sub cboUnits_Click()
Dim conversion As Double

    ' Display the map scale and distance in this unit.
    ' Find a factor to convert from the old units to meters.
    conversion = 1
    If (CurrentUnit = Units.Feet) Then
        conversion = 0.3048
    ElseIf (CurrentUnit = Units.Yards) Then
        conversion = 0.9144
    ElseIf (CurrentUnit = Units.Miles) Then
        conversion = 1609.344
    ElseIf (CurrentUnit = Units.Kilometers) Then
        conversion = 1000
    End If

    ' Find a factor to convert from meters to the new units.
    CurrentUnit = cboUnits.ListIndex
    If (CurrentUnit = Units.Feet) Then
        conversion = conversion * 3.28083
    ElseIf (CurrentUnit = Units.Yards) Then
        conversion = conversion * 1.09361
    ElseIf (CurrentUnit = Units.Miles) Then
        conversion = conversion * 0.000621
    ElseIf (CurrentUnit = Units.Kilometers) Then
        conversion = conversion * 0.001
    End If
    
    ' Convert and display the values.
    If ScaleDistanceInUnits >= 0 Then
        ScaleDistanceInUnits = ScaleDistanceInUnits * conversion
        CurrentDistance = CurrentDistance * conversion
    End If

    DisplayValues
End Sub
Private Function UnitName(ByVal unit_number As Integer) As String
    Select Case unit_number
        Case Units.Undefined
            UnitName = "Unknown"
        Case Units.Miles
            UnitName = "Miles"
        Case Units.Yards
            UnitName = "Yards"
        Case Units.Feet
            UnitName = "Feet"
        Case Units.Kilometers
            UnitName = "Kilometers"
        Case Units.Meters
            UnitName = "Meters"
    End Select
End Function

' Let the user set the scale.
Private Sub cmdSetScale_Click()
    lblInstructions.Caption = "Click and drag from the start and end point of the map's scale bar."
    lblScale.Caption = ""
    picMap.MousePointer = vbCrosshair
    picMap.Cls
    MouseState = MouseStates.ScaleStart
End Sub

' Let the user measure a distance.
Private Sub cmdMeasure_Click()
    lblInstructions.Caption = "Click and draw to select a distance to measure."
    lblDistance.Caption = ""
    picMap.Cls
    picMap.MousePointer = vbCrosshair
    MouseState = MouseStates.MeasureStart
End Sub

' Do stuff with the mouse.
Private Sub picMap_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If MouseState = MouseStates.ScaleStart Then
        ScaleStartX = X
        ScaleStartY = Y
        MouseState = MouseStates.ScaleEnd
    ElseIf MouseState = MouseStates.MeasureStart Then
        Set MeasurementXs = New Collection
        Set MeasurementYs = New Collection
        MeasurementXs.Add X
        MeasurementYs.Add Y
        MouseState = MouseStates.MeasureEnd
    End If
End Sub

Private Sub picMap_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim i As Integer

    If MouseState = MouseStates.ScaleEnd Then
        picMap.Cls
        picMap.Line (ScaleStartX, ScaleStartY)-(X, Y), vbRed
    ElseIf MouseState = MouseStates.MeasureEnd Then
        MeasurementXs.Add X
        MeasurementYs.Add Y
        picMap.Cls
        picMap.CurrentX = MeasurementXs(1)
        picMap.CurrentY = MeasurementYs(1)
        For i = 2 To MeasurementXs.Count
            picMap.Line -(MeasurementXs(i), MeasurementYs(i)), vbRed
        Next i
    End If
End Sub

Private Sub picMap_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim dlg As ScaleDialog
Dim dx As Double
Dim dy As Double
Dim dist As Double
Dim i As Integer

    If MouseState = MouseStates.ScaleEnd Then
        MouseState = MouseStates.Undefined
        picMap.MousePointer = vbDefault
        lblInstructions.Caption = ""

        ' Get the scale.
        Set dlg = New ScaleDialog
        dlg.Show vbModal
        If Not dlg.Canceled Then
            ' Get the distance on the screen.
            dx = X - ScaleStartX
            dy = Y - ScaleStartY
            dist = Sqr(dx * dx + dy * dy)
            If (dist < 1) Then Exit Sub
            ScaleDistanceInPixels = dist

            ' Parse the distance.
            ParseDistanceString dlg.txtScale.Text, _
                ScaleDistanceInUnits, CurrentUnit

            ' Display the units.
            cboUnits.Text = UnitName(CurrentUnit)

            ' Display the scale and measured distance.
            CurrentDistance = -1
            DisplayValues
        End If
    ElseIf MouseState = MouseStates.MeasureEnd Then
        MouseState = MouseStates.Undefined
        picMap.MousePointer = vbDefault
        lblInstructions.Caption = ""

        ' Measure the curve.
        dist = 0
        For i = 2 To MeasurementXs.Count
            dx = MeasurementXs(i) - MeasurementXs(i - 1)
            dy = MeasurementYs(i) - MeasurementYs(i - 1)
            dist = dist + Sqr(dx * dx + dy * dy)
        Next i
    
        ' Convert into the proper units.
        CurrentDistance = dist * ScaleDistanceInUnits / ScaleDistanceInPixels
    
        ' Display the result.
        DisplayValues
    End If
End Sub

' Parse a distance string. Return the length and units.
Private Sub ParseDistanceString(ByVal txt As String, ByRef distance As Double, ByRef unit As Units)
Dim i As Integer
Dim unit_string As String
Dim ch As String

    txt = Trim$(txt)

    ' Find the longest substring that makes sense as a double.
    i = DoublePrefixLength(txt)
    If (i <= 0) Then
        distance = -1
        unit = Units.Undefined
    Else
        ' Get the distance.
        distance = CDbl(Mid$(txt, 1, i))

        ' Get the unit.
        unit_string = LCase$(Mid$(txt, i + 1))
        ch = Mid$(unit_string, 1, 1)
        If Mid$(unit_string, 1, 2) = "mi" Then
            unit = Units.Miles
        ElseIf ch = "y" Then
            unit = Units.Yards
        ElseIf ch = "f" Then
            unit = Units.Feet
        ElseIf ch = "'" Then
            unit = Units.Feet
        ElseIf ch = "k" Then
            unit = Units.Kilometers
        ElseIf ch = "m" Then
            unit = Units.Meters
        Else
            unit = Units.Undefined
        End If
    End If
End Sub

' Return the length of the longest prefix
' string that makes sense as a double.
Private Function DoublePrefixLength(ByVal txt As String) As Integer
Dim i As Integer
Dim test_string As String
Dim test_value As Double

    For i = 1 To Len(txt)
        test_string = Mid$(txt, 1, i)

        On Error Resume Next
        test_value = CDbl(test_string)
        If Err.Number <> 0 Then
            DoublePrefixLength = i - 1
            Exit Function
        End If
        On Error GoTo 0
    Next i

    DoublePrefixLength = Len(txt)
End Function

' Display the units per pixels and the measured distance.
Private Sub DisplayValues()
Dim current_scale As Double

    If (CurrentUnit = Units.Undefined) Or (ScaleDistanceInUnits < 0) Then
        lblScale.Caption = ""
    ElseIf ScaleDistanceInUnits >= 0 Then
        current_scale = ScaleDistanceInUnits / ScaleDistanceInPixels
        lblScale.Caption = ToSignificantDigits(current_scale, 3) & " " & UnitName(CurrentUnit) & "/pixel"
    End If

    If (CurrentDistance < 0) Or (CurrentDistance < 0) Then
        lblDistance.Caption = ""
    Else
        lblDistance.Caption = ToSignificantDigits(CurrentDistance, 3) & " " & UnitName(CurrentUnit)
    End If
End Sub
